/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("com.ibm.rational.report.web.core.app.view.report.AddReportsDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("com.ibm.rational.report.web.core.app.internal.common.CommonDialog");
dojo.requireLocalization("com.ibm.rational.report.web.core.app.view.report", "Messages");
dojo.requireLocalization("com.ibm.rational.report.web.core.app.internal.common", "Messages");

var ReportMessages	= dojo.i18n.getLocalization("com.ibm.rational.report.web.core.app.view.report", "Messages");
var CommonMessages 	= dojo.i18n.getLocalization("com.ibm.rational.report.web.core.app.internal.common", "Messages");

/**
 * Displays the Add Report to Folder dialog.
 */
dojo.declare(
	"com.ibm.rational.report.web.core.app.view.report.AddReportsDialog",
	[dijit._Widget, dijit._Templated],	{
	
	templatePath: dojo.moduleUrl("com.ibm.rational.report.web.core", "app/view/report/templates/AddReportsDialog.html"),

	constructor: function(args) {
		this._args = args;
	},
	
	postCreate: function() {
		this._initText();

		this._selectedNodeId = this._args.nodeId;
		this._selectedNode = null;
		this._selWidget = null;
		
		this._postSave = null;
		this._postCancel = null;
		this._postServiceExec = null;
		
		this._isOwner = false;
		this._isProjectLead = false;
		
		if (typeof this._selectedNodeId == "undefined") {
			this._selectedNodeId = null;
		}
		
		var args = this._args;
		
		if (typeof args.postSave != "undefined") {
			this._postSave = args.postSave;
		}
		
		if (typeof args.postCancel != "undefined") {
			this._postCancel = args.postCancel;
		}
		
		this.searchButton.disabled = true;
		this.okButton.disabled = true;
		
		var self = this;
		
		dojo.connect(this.searchReports, "onfocus",
			function(e){
				self.searchReports.value = "";
				self.searchButton.disabled = true;
		});
				
		dojo.connect(this.searchReports, "onkeyup",
			function(e) {
				e.preventDefault();
				var name = dojo.trim(self.searchReports.value);
				self.searchButton.disabled = (name.length == 0);
			}
		);
		
		this.dialog = new com.ibm.rational.report.web.core.app.internal.common.CommonDialog({
			contentNode: this.contentNode,
			primaryTitle: this._args.title,
			width: "394px",
			isClosable: true
		});
		
		this.cancelButton.focus();
	},
	
	_initText: function() {
		dojox.data.dom.removeChildren(this.okButton);
		this.okButton.appendChild(document.createTextNode(CommonMessages.OK_BUTTON_LABEL));
		
		dojox.data.dom.removeChildren(this.cancelButton);
		this.cancelButton.appendChild(document.createTextNode(CommonMessages.CANCEL_BUTTON_LABEL));
		
		dojox.data.dom.removeChildren(this.searchButton);
		this.searchButton.appendChild(document.createTextNode(CommonMessages.SEARCH_BUTTON_LABEL));
		
		this.searchReports.value = ReportMessages.ADD_REPORTS_VIEWER_SEARCH_TEXT;
	},
	
	close: function() {
		this.dialog.close();
	}
	
});

})();